# Arch Linux

ughhhhhh had to reinstall the test vm like 5 times. finally got lxqt with virtualbox driver to load the desktop
but networking is not working. Perf is kinda shitty. UI is shitty. QT sucks. I hate linux.

##  Setup

* Installation guide https://wiki.archlinux.org/title/Installation_guide
    * Can go through manually or use the new guided installer: `archinstall`

* use btrfs file system
    * I guess I should enable compression but I'm  not sure how it affects perf.

* I tried Luks disk encryption in a VirtualBox VM and I couldn't get into the
  desktop. Locks up on login. Not sure if it's related to this...can try
  encryption on a real install.

* desktop environment
    **VM Test**
        * lxqt, vmware graphics driver, lightdm-slick-greeter

    * lxqt - X11 based. I was using lxde in the past but it was abandoned by
      the original team. They made lxqt. It's QT based which is lame but might
      be fine. This is lightweight and I have my old configs (for LXDE and
      OpenBox) which might still be usable.

    * sway - Wayland based. Martins uses this. I want to try it but it lacks
      nvidia driver support and requires something called wlroots?  I don't
      want to mess with this in my testing vm. Maybe later if I do a proper
      Arch install.
        * https://github.com/tyqualters/sway-nvidia-guide
        * https://www.reddit.com/r/archlinux/comments/yuu7ra/whats_the_difference_between_nvidia_and_nvidiaopen/
        * using seatd for hardware device collection

## Graphics

* card family https://nouveau.freedesktop.org/CodeNames.html
* nvidia driver install guide https://github.com/korvahannu/arch-nvidia-drivers-installation-guide?tab=readme-ov-file


Martins — 06/17/2024 2:59 PM
if you don't want upstream releases then obviously arch is not for you, but
they have simple solution for that - aur, you can keep managing your
dependencies separately from system packages

Martins uses Sway:
Martins — 04/08/2024 10:41 PM
no, .bashrc
I have autologin on tty1
so whenever .bashrc executes on tty1, it starts sway:

    if [ -z "${WAYLAND_DISPLAY}" ] && [ "${XDG_VTNR}" -eq 1 ]; then
      export _JAVA_AWT_WM_NONREPARENTING=1
      export SDL_VIDEODRIVER=wayland
      export GDK_BACKEND=wayland
      export CLUTTER_BACKEND=wayland
      export QT_QPA_PLATFORM=wayland
      export BEMENU_BACKEND=wayland
      export TERMINAL=foot
      export BROWSER=firefox
      export MOZ_ENABLE_WAYLAND=1
      export XDG_SESSION_TYPE=wayland
      export XDG_CURRENT_DESKTOP=sway
      exec systemd-cat -- sway
    fi

Saw this on reddit: sudo pacman -S wayland xorg-xwayland xorg-xlsclients sway swaybg swaylock waybar wofi -y
What is wofi ?


* `config/` -> map contents to `~/.config`.
* `home/` -> map contents to `~/`.


* Store /tmp in RAM
    * 2024: looks like it's done by default. See https://wiki.archlinux.org/title/Tmpfs

* Move browser cache directories to /tmp as a means of reducing file writes on SSD

* Fix fonts by placing the following XML into `/etc/fonts/conf.avail/29-prettify.conf`
  and then symlinking: `ln -s /etc/fonts/conf.avail/29-prettify.conf /etc/fonts/conf.d/29-prettify.conf`

  ```
  <?xml version="1.0"?>
   <!DOCTYPE fontconfig SYSTEM "fonts.dtd">
   <fontconfig>
   <match target="font" >
     <edit mode="assign" name="rgba" >
       <const>rgb</const>
     </edit>
   </match>
   <match target="font" >
     <edit mode="assign" name="hinting" >
       <bool>true</bool>
     </edit>
   </match>
   <match target="font" >
     <edit mode="assign" name="hintstyle" >
       <const>hintslight</const>
     </edit>
   </match>
   <match target="font" >
     <edit mode="assign" name="antialias" >
       <bool>true</bool>
     </edit>
   </match>
   <match target="font">
     <edit mode="assign" name="lcdfilter">
       <const>lcddefault</const>
     </edit>
   </match>
  </fontconfig>
  ```

## Map caps to left-ctrl

* Most promising method

  * Install `xorg-xmodmap`
  * Map `linux/home/Xmodmap` to ~/
  * The above taken from https://wiki.archlinux.org/index.php/xmodmap

* Second method: map caps key to left-ctrl (see https://wiki.archlinux.org/index.php/Map_scancodes_to_keycodes for details)
  * edit `/etc/udev/hwdb.d/10-my-modifiers.hwdb`
  * add:

  ```
  evdev:atkbd:dmi:*            # built-in keyboard: match all AT keyboards for now
   KEYBOARD_KEY_3a=leftctrl     # bind capslock to leftctrl
  ```

  * run `udevadm hwdb --update` then reboot

## Install clipboard getter

* `pi xsel`
* Now we can grab clipboard content in vim using `:read !xsel --clipboard --output`
